org.apache.hc.client5.http.methods

## Class HttpPost

- java.lang.Object
- - org.apache.hc.core5.http.message.HeaderGroup
  - - org.apache.hc.core5.http.message.AbstractHttpMessage
    - - org.apache.hc.client5.http.methods.AbstractExecutionAwareRequest
      - - org.apache.hc.client5.http.methods.HttpRequestBase
        - - org.apache.hc.client5.http.methods.HttpPost

All Implemented Interfaces:
  Serializable, Configurable, HttpExecutionAware, HttpUriRequest, org.apache.hc.core5.http.HttpMessage<org.apache.hc.core5.http.HttpEntity>, org.apache.hc.core5.http.HttpRequest, org.apache.hc.core5.http.MessageHead

    @NotThreadSafe
    public class HttpPost
    extends HttpRequestBase

HTTP POST method.

The HTTP POST method is defined in section 9.5 of RFC2616:

> The POST method is used to request that the origin server accept the entity enclosed in the request as a new subordinate of the resource identified by the Request-URI in the Request-Line. POST is designed to allow a uniform method to cover the following functions:
> - Annotation of existing resources
> - Posting a message to a bulletin board, newsgroup, mailing list, or similar group of articles
> - Providing a block of data, such as the result of submitting a form, to a data-handling process
> - Extending a database through an append operation

Since:
  4.0
See Also:
  Serialized Form

### Field Summary

Fields
`static String` `METHOD_NAME`

### Constructor Summary

Constructors
Constructor and Description
`HttpPost()`
`HttpPost(String uri)`
`HttpPost(URI uri)`

### Method Summary

Methods
`String` `getMethod()` Returns the HTTP method this request uses, such as `GET`, `PUT`, `POST`, or other.

### Methods inherited from class org.apache.hc.client5.http.methods.HttpRequestBase

`getConfig, getProtocolVersion, getRequestLine, getURI, releaseConnection, setConfig, setProtocolVersion, setURI, started, toString`

### Methods inherited from class org.apache.hc.client5.http.methods.AbstractExecutionAwareRequest

`abort, completed, isAborted, reset, setCancellable`

### Methods inherited from class org.apache.hc.core5.http.message.AbstractHttpMessage

`addHeader, getEntity, setEntity, setHeader`

### Methods inherited from class org.apache.hc.core5.http.message.HeaderGroup

`addHeader, clear, containsHeader, containsHeaders, getAllHeaders, getCondensedHeader, getFirstHeader, getHeaders, getLastHeader, headerIterator, headerIterator, removeHeader, removeHeaders, setHeader, setHeaders`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.hc.client5.http.methods.HttpUriRequest

`abort, isAborted`

### Methods inherited from interface org.apache.hc.core5.http.HttpMessage

`addHeader, addHeader, getEntity, removeHeader, removeHeaders, setEntity, setHeader, setHeader, setHeaders`

### Methods inherited from interface org.apache.hc.core5.http.MessageHead

`containsHeader, containsHeaders, getAllHeaders, getFirstHeader, getHeaders, getLastHeader, headerIterator, headerIterator`

### Field Detail

#### METHOD_NAME

    public static final String METHOD_NAME

See Also:
  Constant Field Values

### Constructor Detail

#### HttpPost

    public HttpPost()

#### HttpPost

    public HttpPost(URI uri)

#### HttpPost

    public HttpPost(String uri)

Throws:
  `IllegalArgumentException` - if the uri is invalid.

### Method Detail

#### getMethod

    public String getMethod()

Description copied from interface: `HttpUriRequest`
Returns the HTTP method this request uses, such as `GET`, `PUT`, `POST`, or other.

Specified by:
  `getMethod` in interface `HttpUriRequest`
Specified by:
  `getMethod` in class `HttpRequestBase`